/*
 *     AboutDialog.java  Mar 25, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.gui;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class AboutDialog extends JDialog {
    private JFrame frame;

    public AboutDialog(JFrame frame) {
        super(frame, "About", true);
        this.frame = frame;
        this.setResizable(false);

        createPanes();
    }

    private void createPanes() {
        Container contentPane = this.getContentPane();
        contentPane.setLayout(new BorderLayout());
        contentPane.setBackground(Color.white);

        ImageIcon icon = new ImageIcon(getClass().getResource("images/about.gif"));
        JLabel image = new JLabel(icon);
        contentPane.add(image, "North");
        image.setLayout(null);

        JButton okButton = new JButton("Ok");
        okButton.setLocation(280, 15);
        okButton.setSize(okButton.getPreferredSize());
        image.add(okButton);
        okButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                setVisible(false);
                dispose();
            }
        });

        JLabel versionLabel = new JLabel("Version " + Version.get());
        versionLabel.setLocation(243, 72);
        versionLabel.setSize(versionLabel.getPreferredSize());
        versionLabel.setForeground(Color.darkGray);
        image.add(versionLabel);

        JPanel panel = new JPanel();
        panel.setOpaque(false);
        contentPane.add(panel, "Center");
        panel.setLayout(new FlowLayout(FlowLayout.CENTER));

        JTextArea information = new JTextArea(getInformationText());
        information.setEditable(false);
        information.setFont(new Font("Dialog", Font.BOLD, 12));
        information.setForeground(Color.darkGray);
        information.setBorder(BorderFactory.createEmptyBorder());
        information.setMargin(new Insets(5, 5, 5, 5));
        information.setOpaque(false);
        panel.add(information);

        this.pack();
        this.validate();
        okButton.requestFocus();
    }

    private String getInformationText() {
        StringBuffer buf = new StringBuffer();

        buf.append("Contact:\n");
        buf.append("        Katsuhisa Maruyama\n");
        buf.append("        Department of Computer Science,\n");
        buf.append("        Ritsumeikan University\n");
        buf.append("        mailto: jrbx@jtool.org\n");
        buf.append("        http://www.jtool.org/\n");
        buf.append("\n");
        buf.append("  powered by\n");
        buf.append("        Sapid (http://www.sapid.org/)\n");
        buf.append("        JTool (http://jtool.org/)\n");
        buf.append("        Java2 (http://java.sun.com/)\n");
        buf.append("        Apache XML Xerces (http://xml.apache.org/)\n");
        buf.append("        Apache Jakarta BCEL (http://jakarta.apache.org/)\n");
        buf.append("        Apache Ant (http://xml.apache.org/)\n");
        buf.append("        JUnit (http://www.junit.org/)\n");
        buf.append("\n");
        buf.append("  Copyright 2001-2003 Katsuhisa Maruyama\n");
        buf.append("\n");

        return buf.toString();
    }

    public static void main(String[] args) {
        JFrame frame = new JFrame();
        AboutDialog dialog = new AboutDialog(frame);

        frame.pack();
        frame.validate();
        frame.setVisible(true);
        
        dialog.setVisible(true);
        dialog.dispose();
    }
}
