/*
 *     ClassRefactoring.java  Apr 18, 2005
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.classes;
import org.jtool.jrbx.refactor.*;
import org.jtool.jrbx.refactor.util.*;
import org.jtool.platform.xml.wrapper.*;
import org.jtool.platform.xml.JXConstants;
import java.util.*;
import org.w3c.dom.*;

public class ClassRefactoring extends Refactoring {
    private static final String packagePath = "org.jtool.jrbx.refactor.classes";
    protected JavaClass jclass;
    
    protected ClassRefactoring() {
    }

    public static RefactoringCommand create(String command) {
        return create(command, packagePath);
    }

    public static boolean isEnabled(CodeSelection selection) {
        Element elem = selection.getRepresentativeElem();
        return elem != null && selection.getIds().size() == 1 &&
            elem.getNodeName().equals(JXConstants.ClassElem);
    }

    public void setUp() {
        jclass = new JavaClass(elem);
        jfile = jclass.getJavaFile();
    }

    public void preconditions() throws RefactoringException {
    }

    public void transform() throws RefactoringException {
    }

    public void additionalTransformation() throws RefactoringException {
    }

    public String getLog() {
        return "Class Refactoring: " + jclass.getName();
    }
}
