/*
 *     ExtractClass.java  Aug 9, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.classes;
import org.jtool.jrbx.refactor.*;
import org.jtool.jrbx.refactor.query.*;
import org.jtool.platform.xml.wrapper.*;

public class ExtractClass extends ClassRefactoring {
    protected String newName = null;

    protected ExtractClass() {
    }

    public void preconditions() throws RefactoringException {
        if (newName == null) {
            throw new RefactoringException("");
        }

        checkExtractedClass();
    }
    
    private void checkExtractedClass() throws RefactoringException {
        if (QueryFile.hasTheClass(jfile, newName)) {
            throw new RefactoringException("Not extract:" +
              " the class/interface " + newName + " already exists in the file " + getRelativeName(jfile.getName()));
        }

        JavaClass jc = QueryFile.getJavaClassWithTheSameName(jfile, newName);
        if (jc != null) {
            if (jclass.isInTheSamePackage(jc)) {
                throw new RefactoringException("Not extract:" +
                 " the class/interface " + newName + " already exists in the package " + jc.getJavaFile().getPackageName());
            }
        }
    }
}
