/*
 *     ExtractSuperclass.java  Apr 18, 2005
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.classes;
import org.jtool.jrbx.refactor.*;
import org.jtool.jrbx.refactor.dialog.*;
import javax.swing.JFrame;

public class ExtractSuperclass extends ExtractClass {
    private ExtractSuperclassTransformer transformer;

    public ExtractSuperclass() {
        super();
    }

    public void setUpWithOptions(JFrame f, String newName) {
        frame = f;
        this.newName = newName;
    }

    public void preconditions() throws RefactoringException {
        if (newName == null) {
            NewClassNameDialog dialog = new NewClassNameDialog(frame, "Extract Superclass");
            newName = dialog.getNewName();
        }

        super.preconditions();
    }

    public void transform() throws RefactoringException {
        transformer = new ExtractSuperclassTransformer(jclass, newName);
        transformer.changeSrc();
        unparse(jfile);
    }

    public String getLog() {
        return newName + " from " + jclass.getName() + " in " + getRelativeName(jfile.getName());
    }

    public String getUndoInformation() {
        return "C:" + jfile.getPackageName() + "#" + jclass.getName();
    }
}
