/*
 *     ExtractSuperclassTransformer.java  Jan 31, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.classes;
import org.jtool.jrbx.refactor.util.*;
import org.jtool.platform.xml.wrapper.*;
import org.w3c.dom.*;

public class ExtractSuperclassTransformer extends RefactoringTransformer {
    private JavaClass jclass;
    private String newName;

    private ExtractSuperclassTransformer() {
    }

    public ExtractSuperclassTransformer(JavaClass jclass, String newName) {
        this.jclass = jclass;
        this.newName = newName;
    }

    public void changeSrc() {
        changeClassDeclName();
        insertNewClassDecl();
    }

    private void changeClassDeclName() {
        Node node = jclass.getExtendsIdentNode();
        if (node.getNodeName().length() != 0) {
            rename(newName, node);
        } else {
            insertCodeAfter(" extends " + newName, jclass.getIdentNode());
        }            
    }

    private void insertNewClassDecl() {
        Node node = jclass.getElem();

        StringBuffer buf = new StringBuffer();
        buf.append("class " + newName);

        String extendsName = jclass.getExtendsIdentName();
        if (extendsName.length() != 0) {
            buf.append(" extends " + jclass.getExtendsIdentName());
        }
        buf.append(" {\n");
        buf.append("}\n");
        buf.append("\n");

        insertCodeBefore(buf.toString(), node);
    }
}
