/*
 *     MoveClassTransformer.java  Feb 5, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.classes;
import org.jtool.jrbx.refactor.util.*;
import org.jtool.jrbx.refactor.query.*;
import org.jtool.platform.xml.wrapper.*;
import java.util.*;
import org.w3c.dom.*;

public class MoveClassTransformer extends RefactoringTransformer {
    private JavaClass jclass;

    private MoveClassTransformer() {
    }

    public MoveClassTransformer(JavaClass jclass) {
        this.jclass = jclass;
    }

    public void changeSrc() {
        delete(jclass);
    }

    public void changeDst(JavaFile dfile) {
        Node node = insert(jclass, dfile);
        insertCodeAfter("\n", node);

        JavaClassList classes = QueryClass.getJavaClassesUsedByTheClass(jclass);
        ArrayList imports = dfile.getImportNodes();

        Iterator it = jclass.getJavaFile().getImportNodes().iterator();
        while (it.hasNext()) {
            JavaImport ji = new JavaImport((Element)it.next());

            if (QueryImport.hasImported(ji, classes) && !QueryImport.hasImported(ji, imports)) {
                insert(ji, dfile);
            }
        }
    }

    public void changeRef(JavaFile rfile, String pname) {
        insertImportCode(pname + "." + jclass.getName(), rfile);
    }
}
