/*
 *     JavaIdentifier.java  Feb 6, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.dialog;

public class JavaIdentifier {
    static final String[] keywords = {
        "abstract", "boolean", "break", "byte", "case",
        "catch", "char", "class", "const", "continue",
        "default", "do", "double", "else", "extends",
        "final", "finally", "float", "for", "goto",
        "if", "implements", "import", "instanceof", "int",
        "interface", "long", "native", "new", "package",
        "private", "protected", "public", "return", "short",
        "static", "strictfp", "super", "switch", "synchronized",
        "this", "throw", "throws", "transient", "try",
        "void", "volatile", "while"
    };

    static final String[] specials = {
        "true", "false", "null"
    };

    public static boolean isValid(String name) {
        if (name.length() == 0) {
            return false;
        }

        if (!Character.isLetter(name.charAt(0)) &&
            name.charAt(0) != '_') {
            return false;
        }
        for (int i = 1; i < name.length(); i++) {
            if (!Character.isLetterOrDigit(name.charAt(i)) &&
                name.charAt(i) != '_') {
                return false;
            }
        }

        if (isJavaKeyword(name) || isJavaSpecials(name)) {
            return false;
        }

        return true;
    }

    public static boolean isJavaKeyword(String name) {
        for (int i = 0; i < keywords.length; i++) {
            if (name.equals(keywords[i])) {
                return true;
            }
        }
        return false;
    }

    public static boolean isJavaSpecials(String name) {
        for (int i = 0; i < specials.length; i++) {
            if (name.equals(specials[i])) {
                return true;
            }
        }
        return false;
    }
}
