/*
 *     NewClassNameDialog.java  Aug 9, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.dialog;
import javax.swing.*;
import java.awt.event.*;

public class NewClassNameDialog extends NewNameDialog {
    private JRadioButton publicOption;
    private JRadioButton noneOption;

    public NewClassNameDialog(JFrame frame, String title) {
        super(frame, title, "Input a new class name:");
    }

    protected JPanel createCenterPane() {
        JPanel box = super.createCenterPane();

        ButtonGroup group = new ButtonGroup();
        publicOption = new JRadioButton("public", false);
        noneOption = new JRadioButton("none", true);
        group.add(publicOption);
        group.add(noneOption);

        JPanel optionPanel = new JPanel();
        optionPanel.add(publicOption);
        optionPanel.add(noneOption);

        box.add(optionPanel);

        return box;
    }

    public static NewClassNameDialog show(JFrame frame, String title) {
        return new NewClassNameDialog(frame, title);
    }

    public boolean getPublicOption() {
        return publicOption.getModel().isSelected();
    }

    public boolean getNoneOption() {
        return noneOption.getModel().isSelected();
    }

    public static void main(String args[]) {
        JFrame mainFrame = new JFrame();
        mainFrame.setSize(100, 100);
        mainFrame.setVisible(true);

        NewClassNameDialog dialog = NewClassNameDialog.show(mainFrame, "New name");
        System.out.println("NAME = " + dialog.getNewName());
        System.exit(0);
    }
}
