/*
 *     NewMethodNameDialog.java  Aug 9, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.dialog;
import javax.swing.*;
import java.awt.event.*;

public class NewMethodNameDialog extends NewNameDialog {
    private JRadioButton publicOption;
    private JRadioButton protectedOption;
    private JRadioButton privateOption;
    private JRadioButton noneOption;

    public NewMethodNameDialog(JFrame frame, String title) {
        super(frame, title, "Input a new method name:");
    }

    protected JPanel createCenterPane() {
        JPanel box = super.createCenterPane();

        ButtonGroup group = new ButtonGroup();
        publicOption = new JRadioButton("public", false);
        protectedOption = new JRadioButton("protected", false);
        privateOption = new JRadioButton("private", false);
        noneOption = new JRadioButton("none", true);
        group.add(publicOption);
        group.add(protectedOption);
        group.add(privateOption);
        group.add(noneOption);

        JPanel optionPanel = new JPanel();
        optionPanel.add(publicOption);
        optionPanel.add(protectedOption);
        optionPanel.add(privateOption);
        optionPanel.add(noneOption);

        box.add(optionPanel);

        return box;
    }

    public static NewMethodNameDialog show(JFrame frame, String title) {
        return new NewMethodNameDialog(frame, title);
    }

    public boolean getPublicOption() {
        return publicOption.getModel().isSelected();
    }

    public boolean getProtectedOption() {
        return protectedOption.getModel().isSelected();
    }

    public boolean getPrivateOption() {
        return publicOption.getModel().isSelected();
    }

    public boolean getNoneOption() {
        return noneOption.getModel().isSelected();
    }

    public static void main(String args[]) {
        JFrame mainFrame = new JFrame();
        mainFrame.setSize(100, 100);
        mainFrame.setVisible(true);

        NewMethodNameDialog dialog = NewMethodNameDialog.show(mainFrame, "New name");
        System.out.println("NAME = " + dialog.getNewName());
        System.exit(0);
    }
}
