/*
 *     NewNameDialog.java  Aug 29, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.dialog;
import javax.swing.*;
import java.awt.event.*;

public class NewNameDialog extends SimpleDialog {
    private JTextField newNameField;
    private String newName;

    public NewNameDialog(JFrame frame, String title, String mesg) {
        super(frame, title, mesg);
    }

    protected JPanel createCenterPane() {
        JPanel box = super.createCenterPane();
        box.setLayout(new BoxLayout(box, BoxLayout.Y_AXIS));

        newNameField = createInputTextField(box, "New name: ");
        newNameField.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                okButton.requestFocus();
            }
        });
        newNameField.requestFocus();
        return box;
    }

    protected void okAction() {
        newName = newNameField.getText();
        if (!JavaIdentifier.isValid(newName)) {
            JOptionPane.showMessageDialog(frame, "Invalid string: \"" + newName + "\"");
        } else {
            setVisible(false);
            dispose();
        }
    }

    protected void cancelAction() {
        newName = null;
        setVisible(false);
        dispose();
    }

    public String getNewName() {
        return newName;
    }
}
