/*
 *     RenameDialog.java  Aug 9, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.dialog;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class RenameDialog extends ReplaceDialog {
    private JCheckBox updateCheckBox;

    public RenameDialog(JFrame frame, String title, String oldName) {
        super(frame, title, oldName);
    }

    protected JPanel createCenterPane() {
        JPanel box = super.createCenterPane();

        updateCheckBox = new JCheckBox("Update references", true);
        box.add(updateCheckBox);

        return box;
    }

    public static RenameDialog show(JFrame frame, String title, String oldName) {
        return new RenameDialog(frame, title, oldName);
    }

    public boolean getUpdateCheckBox() {
        return updateCheckBox.getModel().isSelected();
    }

    public static void main(String args[]) {
        if (args.length == 1) {
            JFrame mainFrame = new JFrame();
            mainFrame.setSize(100, 100);
            mainFrame.setVisible(true);

            RenameDialog dialog = RenameDialog.show(mainFrame, "Rename", args[0]);
            String name = dialog.getNewName();
            boolean update = dialog.getUpdateCheckBox();

            System.out.println("NAME = " + name + " " + update);
            System.exit(0);
        }
        System.out.println("java RenameDialog old_name");
    }
}
