/*
 *     RenameFieldDialog.java  Aug 9, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.dialog;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class RenameFieldDialog extends ReplaceDialog {
    private JCheckBox updateCheckBox;
    private String getter;
    private String setter;
    private JCheckBox getterCheckBox;
    private JCheckBox setterCheckBox;

    public RenameFieldDialog(JFrame frame, String title, String oldName,
                             String getter, String setter) {
        super(frame, title, oldName);
        this.getter = getter;
        this.setter = setter;
    }

    protected JPanel createCenterPane() {
        JPanel box = super.createCenterPane();

        updateCheckBox = new JCheckBox("Update references", true);
        box.add(updateCheckBox);

        getterCheckBox = new JCheckBox("Getter: " + getter, true);
        box.add(getterCheckBox);

        setterCheckBox = new JCheckBox("Setter: " + setter, true);
        box.add(setterCheckBox);

        return box;
    }

    public static RenameFieldDialog show(JFrame frame, String title, String oldName,
                                         String getter, String setter) {
        return new RenameFieldDialog(frame, title, oldName, getter, setter);
    }

    public boolean getUpdateCheckBox() {
        return updateCheckBox.getModel().isSelected();
    }

    public boolean getGetterCheckBox() {
        return getterCheckBox.getModel().isSelected();
    }

    public boolean getSetterCheckBox() {
        return setterCheckBox.getModel().isSelected();
    }

    public static void main(String args[]) {
        if (args.length == 3) {
            JFrame mainFrame = new JFrame();
            mainFrame.setSize(100, 100);
            mainFrame.setVisible(true);

            RenameFieldDialog dialog = RenameFieldDialog.show(mainFrame, "Rename", args[0], args[1], args[2]);
            String name = dialog.getNewName();
            boolean update = dialog.getUpdateCheckBox();
            boolean gcheck = dialog.getGetterCheckBox();
            boolean scheck = dialog.getGetterCheckBox();

            System.out.println("NAME = " + name + " " + update + " " + gcheck + " " + scheck);
            System.exit(0);
        }
        System.out.println("java RenameDialog old_name");
    }
}
