/*
 *     ReplaceDialog.java  Jan 11, 2006
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.dialog;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class ReplaceDialog extends SimpleDialog {
    private JTextField oldNameField;
    private JTextField newNameField;
    private String newName;

    public ReplaceDialog(JFrame frame, String title, String oldName) {
        super(frame, title, "Input new class, method, field, or variable name:", oldName);
    }

    protected JPanel createCenterPane() {
        JPanel box = new JPanel();
        box.setLayout(new BoxLayout(box, BoxLayout.Y_AXIS));

        oldNameField = createInputTextField(box, "Old name:   ");
        oldNameField.setBackground(new Color(220, 220, 220));
        oldNameField.setEditable(false);
        oldNameField.setText(name);

        newNameField = createInputTextField(box, "New name: ");
        newNameField.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                okButton.requestFocus();
            }
        });

        newNameField.requestFocus();
        return box;
    }

    protected void okAction() {
        newName = newNameField.getText();
        if (!JavaIdentifier.isValid(newName)) {
            JOptionPane.showMessageDialog(frame, "Invalid string: \"" + newName + "\"");
        } else {
            setVisible(false);
            dispose();
        }
    }
        
    protected void cancelAction() {
        newName = null;
        setVisible(false);
        dispose();
    }
        
    public String getNewName() {
        return newName;
    }
}
