/*
 *     MoveFieldTransformer.java  Feb 2, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.fields;
import org.jtool.jrbx.refactor.util.*;
import org.jtool.jrbx.refactor.query.*;
import org.jtool.platform.xml.JXConstants;
import org.jtool.platform.xml.wrapper.*;
import org.w3c.dom.*;
import java.util.*;

public class MoveFieldTransformer extends RefactoringTransformer {
    private JavaField jfield;
    private boolean isStatic = false;

    private MoveFieldTransformer() {
    }

    public MoveFieldTransformer(JavaField jfield) {
        this.jfield = jfield;
        this.isStatic = isStatic;
    }

    public void changeSrc() {
        delete(jfield);
    }

    public void changeDst(JavaClass dclass) {
        insert(jfield, dclass);
    }

    public void changeRef(JavaFile rfile, JavaClass dclass) {
        Iterator it = QueryFile.getJavaVariablesUsingTheField(rfile, jfield).iterator();
        while (it.hasNext()) {
            JavaVariable jv = (JavaVariable)it.next();

            Node node = jv.getFirstChildNode(jv.getDotPrefix(), JXConstants.IdentElem);
            rename(dclass.getName(), node);
        }
    }
}
