/*
 *     PushDownFieldTransfor.java  Feb 7, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.fields;
import org.jtool.jrbx.refactor.util.*;
import org.jtool.platform.xml.wrapper.*;
import org.w3c.dom.*;
import java.util.*;

public class PushDownFieldTransformer extends RefactoringTransformer {
    private JavaField jfield;

    private PushDownFieldTransformer() {
    }

    public PushDownFieldTransformer(JavaField jfield) {
        this.jfield = jfield;
    }

    public void changeSrc() {
        delete(jfield);
    }

    public void changeDst(JavaClass dclass) {
        insert(jfield, dclass);
        eliminateDotPrefix(dclass, jfield, "super");
    }

    public void changeRef(JavaFile rfile, String refName) {
        renameDotPrefix(rfile, jfield, refName);
    }
}
