/*
 *     RenameFieldTransformer.java  Aug 9, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.fields;
import org.jtool.jrbx.refactor.util.*;
import org.jtool.platform.xml.wrapper.*;
import org.jtool.jrbx.refactor.query.*;
import java.util.*;
import org.w3c.dom.*;

public class RenameFieldTransformer extends RefactoringTransformer {
    private JavaField jfield;
    private String newName;

    private RenameFieldTransformer() {
    }

    public RenameFieldTransformer(JavaField jfield, String newName) {
        this.jfield = jfield;
        this.newName = newName;
    }

    public void changeSrc() {
        rename(newName, jfield);
    }

    public void changeRef(JavaFile rfile) {
        Iterator it = QueryFile.getJavaVariablesUsingTheField(rfile, jfield).iterator();
        while (it.hasNext()) {
            JavaVariable jv = (JavaVariable)it.next();
            rename(newName, jv);
        }
    }
}
