/*
 *     PushDownMethodTransformer.java  Feb 7, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.methods;
import org.jtool.jrbx.refactor.util.*;
import org.jtool.platform.xml.wrapper.*;
import java.util.*;
import org.w3c.dom.*;

public class PushDownMethodTransformer extends RefactoringTransformer {
    private JavaMethod jmethod;

    private PushDownMethodTransformer() {
    }

    public PushDownMethodTransformer(JavaMethod jmethod) {
        this.jmethod = jmethod;
    }

    public void changeSrc() {
        delete(jmethod);
    }

    public void changeDst(JavaClass dclass) {
        insert(jmethod, dclass);
        eliminateDotPrefix(dclass, jmethod, "super");
    }

    public void changeRef(JavaFile rfile, String refName) {
        renameDotPrefix(rfile, jmethod, refName);
    }
}
