/*
 *     StatementRefactoring.java  Apr 18, 2005
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.statements;
import org.jtool.jrbx.refactor.*;
import org.jtool.jrbx.refactor.util.*;
import org.jtool.platform.xml.wrapper.*;
import org.jtool.platform.xml.JXConstants;
import java.util.*;
import org.w3c.dom.*;

public class StatementRefactoring extends Refactoring {
    private static final String packagePath = "org.jtool.jrbx.refactor.statements";
    protected JavaStatement jstatement;
    protected JavaClass jclass;
    protected JavaMethod jmethod;

    protected StatementRefactoring() {
    }

    public static RefactoringCommand create(String command) {
        return create(command, packagePath);
    }

    public static boolean isEnabled(CodeSelection selection) {
        Element elem = selection.getRepresentativeElem();
        return elem != null && selection.getIds().size() == 1 &&
            elem.getNodeName().equals(JXConstants.StatementElem);
    }

    public static boolean isEnabledSwitch(CodeSelection selection) {
        Element elem = selection.getRepresentativeElem();
        return isEnabled(selection) &&
            elem.getAttribute(JXConstants.SortAttr).equals(JXConstants.Switch);
    }

    public static boolean isEnabledIf(CodeSelection selection) {
        Element elem = selection.getRepresentativeElem();
        return isEnabled(selection) &&
            elem.getAttribute(JXConstants.SortAttr).equals(JXConstants.If);
    }

    public static boolean isEnabledWhile(CodeSelection selection) {
        Element elem = selection.getRepresentativeElem();
        return isEnabled(selection) &&
            elem.getAttribute(JXConstants.SortAttr).equals(JXConstants.While);
    }

    public static boolean isEnabledDo(CodeSelection selection) {
        Element elem = selection.getRepresentativeElem();
        return isEnabled(selection) &&
            elem.getAttribute(JXConstants.SortAttr).equals(JXConstants.Do);
    }

    public static boolean isEnabledFor(CodeSelection selection) {
        Element elem = selection.getRepresentativeElem();
        return isEnabled(selection) &&
            elem.getAttribute(JXConstants.SortAttr).equals(JXConstants.For);
    }

    public void setUp() {
        jstatement = new JavaStatement(elem);
        jclass = jstatement.getJavaClass();
        jmethod = jstatement.getJavaMethod();
        jfile = jstatement.getJavaFile();
    }

    public void preconditions() throws RefactoringException {
    }
    
    public void transform() throws RefactoringException {
    }

    public void additionalTransformation() throws RefactoringException {
    }

    public void postconditions() throws RefactoringException {
    }

    public String getLog() {
        return "Statement Refactoring: " + jstatement.getSort();
    }
}
