/*
 *     CodeHighlighter.java  Feb 20, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.util;
import org.jtool.jrbx.refactor.query.*;
import org.jtool.platform.xml.wrapper.*;
import org.jtool.platform.xml.JXConstants;
import java.util.*;
import org.w3c.dom.*;

public class CodeHighlighter {

    public static void run(JavaFile jfile, JavaClass jclass) {
        Iterator it = QueryFile.getJavaTypesUsingTheClass(jfile, jclass).iterator();
        while (it.hasNext()) {
            JavaType jt = (JavaType)it.next();
            
            setHighlight(jfile, jt.getElem());
        }
    }

    public static void run(JavaFile jfile, JavaMethod jmethod) {
        Iterator it = QueryFile.getJavaCallsUsingTheMethod(jfile, jmethod).iterator();
        while (it.hasNext()) {
            JavaCall ja = (JavaCall)it.next();
            
            setHighlight(jfile, ja.getElem());
        }
    }

    public static void run(JavaFile jfile, JavaField jfield) {
        Iterator it = QueryFile.getJavaVariablesUsingTheField(jfile, jfield).iterator();
        while (it.hasNext()) {
            JavaVariable jv = (JavaVariable)it.next();
            
            setHighlight(jfile, jv.getElem());
        }
    }

    public static void run(JavaFile jfile, ArrayList nodes) {
        Iterator it = nodes.iterator();
        while (it.hasNext()) {
            Element elem = (Element)it.next();
         
            setHighlight(jfile, elem);   
        }
    }
    
    private static void setHighlight(JavaFile jfile, Element elem) {          
        Node node = jfile.getFirstChildNode(elem, JXConstants.IdentElem);
        ((Element)node).setAttribute(RefactoringConstants.ChangeAttr, RefactoringConstants.REFERENCE);
    }
}
