/*
 *     DisplayedCode.java  Dec 3, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.util;
import java.util.*;
import java.io.*;

public class DisplayedCode {
    private String name;
    private String oldCode;
    private String newCode;
    private ArrayList oldHighlights = new ArrayList();  // HighlightToken
    private ArrayList newHighlights = new ArrayList();  // HighlightToken

    private DisplayedCode() {
    }

    public DisplayedCode(String name, String oldCode, String newCode) {
        this.name = name;
        this.oldCode = oldCode;
        this.newCode = newCode;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public String getBaseName() {
        int index = name.lastIndexOf(File.separator);
        if (index != -1) {
            return name.substring(index + 1);
        }
        return name;
    }

    public void setOldCode(String code) {
        oldCode = code;
    }

    public String getOldCode() {
        return oldCode;
    }

    public void setNewCode(String code) {
        newCode = code;
    }

    public String getNewCode() {
        return newCode;
    }

    public void setOldHighlight(ArrayList highlights) {
        oldHighlights = highlights;
    }

    public void addOldHighlight(ArrayList highlights) {
        oldHighlights.addAll(highlights);
    }

    public ArrayList getOldHighlight() {
        return oldHighlights;
    }

    public void setNewHighlight(ArrayList highlights) {
        newHighlights = highlights;
    }

    public void addNewHighlight(ArrayList highlights) {
        newHighlights.addAll(highlights);
    }

    public ArrayList getNewHighlight() {
        return newHighlights;
    }
}
