/*
 *     Modifier.java  Dec 3, 2003
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.util;
import org.jtool.platform.xml.JXConstants;
import java.util.*;

public class Modifier {
    private ArrayList modifiers = new ArrayList();  // String

    public static final String PUBLIC = "public";
    public static final String PROTECTED = "protected";
    public static final String PRIVATE = "private";
    public static final String ABSTRACT = "abstract";
    public static final String STATIC = "static";
    public static final String FINAL = "final";
    public static final String VOLATILE = "volatile";
    public static final String SYNCHRONIZED = "synchronized";
    public static final String TRANSIENT = "transient";
    public static final String STRICTFP = "strictfp";
    public static final String VOID = "void";

    public Modifier() {
    }

    public void add(String keyword) {
        if (!modifiers.contains(keyword)) {
            modifiers.add(keyword);
        }
    }

    public void add(int index, String keyword) {
        modifiers.add(index, keyword);
    }

    public int remove(String keyword) {
        int index = modifiers.indexOf(keyword);
        modifiers.remove(keyword);
        return index;
    }

    public boolean has(String keyword) {
        Iterator it = modifiers.iterator();
        while (it.hasNext()) {
            String modifier = (String)it.next();
            if (modifier.equals(keyword)) {
                return true;
            }
        }
        return false;
    }

    public boolean isEmpty() {
        if (modifiers.size() == 0) {
            return true;
        }
        return false;
    }

    public int indexOf(String keyword) {
        return modifiers.indexOf(keyword);
    }

    public String toString() {
        StringBuffer buf = new StringBuffer();

        for (int i = 0; i < modifiers.size(); i++) {
            if (i != 0) {
                buf.append(" ");
            }
            buf.append((String)modifiers.get(i));
        }

        return buf.toString();
    }
}
