/*
 *     DeleteVariable.java  Aug 9, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.variables;
import org.jtool.jrbx.refactor.*;
import org.jtool.jrbx.refactor.query.*;
import org.jtool.platform.xml.wrapper.*;
import java.util.*;
import javax.swing.JFrame;

public class DeleteVariable extends VariableRefactoring {
    private DeleteVariableTransformer transformer;

    public DeleteVariable() {
        super();
    }

    public void setUpWithOptions(JFrame f) {
        frame = f;
    }

    public void preconditions() throws RefactoringException {
        checkAlreadyUsed();
    }

    public void transform() throws RefactoringException {
        transformer = new DeleteVariableTransformer(jvar);
        transformer.changeSrc();
        unparse(jfile);
    }

    public void additionalTransformation() throws RefactoringException {
        if (jvar.isParameter()) {
            int pindex = jmethod.getParameterIndex((JavaParameter)jvar);

            ArrayList files = QueryProject.getAllJavaFilesCallingTheMethod(jmethod);
            Iterator it = files.iterator();
            while (it.hasNext()) {
                JavaFile jf = (JavaFile)it.next();

                transformer.changeRef(jf, jmethod, pindex);
                unparse(jf);
            }
        }
    }

    public String getLog() {
        return jvar.getName() + " in " + jmethod.getName();
    }

    private void checkAlreadyUsed() throws RefactoringException {
        if (QueryMethod.usesTheVariable(jmethod, jvar.getName())) {
            throw new RefactoringException("Not delete:" +
              " the variable " + jvar.getName() + " is used in the method " + jmethod.getName());
        }
    }
}
