/*
 *     DeleteVariableTransformer.java  Mar 25, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.variables;
import org.jtool.jrbx.refactor.util.*;
import org.jtool.jrbx.refactor.query.*;
import org.jtool.platform.xml.wrapper.*;
import java.util.*;

public class DeleteVariableTransformer extends RefactoringTransformer {
    private JavaLocal jvar;
    
    private DeleteVariableTransformer() {
    }

    public DeleteVariableTransformer(JavaLocal jvar) {
        this.jvar = jvar;
    }

    public void changeSrc() {
        if (jvar.isLocal()) {
            delete((JavaLocal)jvar);
        } else {
            delete((JavaParameter)jvar);
        }
    }

    public void changeRef(JavaFile rfile, JavaMethod jmethod, int pindex) {
        Iterator it = QueryFile.getJavaCallsUsingTheMethod(rfile, jmethod).iterator();
        while (it.hasNext()) {
            JavaCall ja = (JavaCall)it.next();

            delete(ja, pindex);
        }
    }
}
