/*
 *     RenameVariableTransformer.java  Feb 10, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.variables;
import org.jtool.jrbx.refactor.util.*;
import org.jtool.platform.xml.wrapper.*;
import java.util.*;
import org.w3c.dom.*;

public class RenameVariableTransformer extends RefactoringTransformer {
    private JavaLocal jvar;
    private String newName;

    private RenameVariableTransformer() {
    }

    public RenameVariableTransformer(JavaLocal jvar, String newName) {
        this.jvar = jvar;
        this.newName = newName;
    }

    public void changeSrc() {
        changeUsingName(newName);
    }

    private void changeUsingName(String newName) {
        Iterator it = jvar.getJavaMethod().getVariableList().iterator();
        while (it.hasNext()) {
            JavaVariable jv = (JavaVariable)it.next();

            if ((jv.isLocal() || jv.isParameter()) &&
                jv.getName().equals(jvar.getName())) {
                rename(newName, jv);
            }
        }
    }
}
