/*
 *     VariableRefactoring.java  Apr 18, 2005
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.variables;
import org.jtool.jrbx.refactor.*;
import org.jtool.jrbx.refactor.util.*;
import org.jtool.platform.xml.wrapper.*;
import org.jtool.platform.xml.JXConstants;
import java.util.*;
import org.w3c.dom.*;

public class VariableRefactoring extends Refactoring {
    private static final String packagePath = "org.jtool.jrbx.refactor.variables";
    protected JavaLocal jvar;
    protected JavaClass jclass;
    protected JavaMethod jmethod;

    protected VariableRefactoring() {
    }

    public static RefactoringCommand create(String command) {
        return create(command, packagePath);
    }

    public static boolean isEnabled(CodeSelection selection) {
        Element elem = selection.getRepresentativeElem();
        return elem != null && selection.getIds().size() == 1 && 
            (elem.getNodeName().equals(JXConstants.LocalElem) || elem.getNodeName().equals(JXConstants.ParameterElem));
    }

    public void setUp() {
        jvar = getJavaLocal(elem);
        jclass = jvar.getJavaClass();
        jmethod = jvar.getJavaMethod();
        jfile = jvar.getJavaFile();
    }

    private JavaLocal getJavaLocal(Element e) {
        if (e.getNodeName().equals(JXConstants.ParameterElem)) {
            return new JavaParameter(e);
        } else if (e.getNodeName().equals(JXConstants.LocalElem)) {
            return new JavaLocal(e);
        }
        return null;
    }
            
    public void preconditions() throws RefactoringException {
    }

    public void transform() throws RefactoringException {
    }

    public void additionalTransformation() throws RefactoringException {
    }

    public String getLog() {
        return "Variable Refactoring: " + jvar.getName();
    }
}
